#!/home/artur/programs/tcl8.4.3-atkdebugger/unix/tclsh

source [file join [file dirname [info script]] debugger.tcl]

wm withdraw .

# Start Debuggsession

proc innerTestProc {p1 p2} {
    set debug_info "Debugging in normall byte coded procedures"
    set a $p1
    set b $p2
    set c [expr $a + $b]
    puts ree
    if {$a>$b} {
	return
    }
}
proc testproc {} {
    set debug_info "Debugging in normall byte coded procedures"
    # this test proc for debugging
    set a 12
    set b $a
    # the next procedure invoke the debugging session
    atk::halt
    puts "step 1"
    innerTestProc 1 2
    puts "step 2"
    set b $a
    # Press Resume to try second example that invoke debugger per a breakpoint
}

#testproc

proc testA param1 {
    set a 3
    set b $param1
}
proc testB {} {
    set debug_info "Debugging in normall byte coded procedures with breakpoint"
    set a 3
    testC
    # Here was the breakpoint set
    # per method atk::breakpoint add testB 60
    set b c
    testC
    testA 43
    set b "$b - $a"
}
proc testC {} {
    set a {12 ew}
    set b [lindex $a 1]
}

atk::breakpoint add testB 60
testB

#testing debugging in global context

atk::halt
set a 3
set b [list $a $a]
set c [list]
foreach elem $b {
    set c [linsert $c 0 $elem]
}
puts $c
eval {
    set a 3
    set b [list $a $a]
    set c [list]
    foreach elem $b {
	set c [linsert $c 0 $elem]
    }
}

#testing eval in procedures
proc procWithEval {a b} {
    atk::halt
    set ret [list $a $b]
    eval {
	set b $ret
	set length [llength $ret]
    }
    return [list $length $ret $b]
}

procWithEval 1 2

#testing uplevel
proc upLevelProc {count action} {
    for {set x 0} {$x<$count} {incr x} {
	uplevel $action
    }
}

proc useUpLevelProc {} {
    atk::halt
    set a 1
    set b [list]
    set debug_info "The last word will be evaluated in this context but from upLevelProc"
    upLevelProc 4 {
	incr a 2
	lappend b $a
    }
    set c $b
}

useUpLevelProc

#testion global evaluation from proc
proc procWithGlobalEval {} {
    atk::halt
    namespace eval :: { set atk wasSetting }
}

procWithGlobalEval

proc testD {} {
    set e er
    # this line caused error
    set b $c
}
proc testE {} {
    set debug_info "Debugging in normall byte coded from error case"
    catch {
	set a dummy
	# This should not produce error because of catch
	testD
    }
    set a ber
    testD
}

testE

exit
